var DeliciousBlogRescue = {
  
  urlDeliciousAPI: "https://api.del.icio.us/v1/",
  // SJW:20080804
  // Switch to ALL api since get + datetime API is currently broken
  //urlGet: "posts/get?",
  urlGet: "posts/all?",
  urlDel: "http://delicious.com/",
  prefs: null,
  blogFaultStr: "",
  
  restoreState: function() {      
    this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefBranch);
    try { 
      var del = this.prefs.getCharPref("extensions.deliciousblogrescue.delAcc");
      var tindex = this.prefs.getIntPref("extensions.deliciousblogrescue.runTimeIndex");
      var blog = this.prefs.getCharPref("extensions.deliciousblogrescue.blogAcc");
      var dest = this.prefs.getCharPref("extensions.deliciousblogrescue.destURL");
      var blogid = this.prefs.getCharPref("extensions.deliciousblogrescue.blogID");
      var catid = this.prefs.getCharPref("extensions.deliciousblogrescue.catID");
      
      document.getElementById("delAcc").value = del;
      document.getElementById("runTime").selectedIndex = tindex;
      document.getElementById("blogAcc").value = blog;
      document.getElementById("destURL").value = dest;
      document.getElementById("blogID").value = blogid;
      document.getElementById("catID").value = catid;
    }
    catch(e) {}
  },

  saveState: function() {                                                   
    var delAcc = document.getElementById("delAcc").value;
    var runTimeIndex = document.getElementById("runTime").selectedIndex;
    var blogAcc = document.getElementById("blogAcc").value;
    var destURL = document.getElementById("destURL").value;
    var blogID = document.getElementById("blogID").value;
    var catID = document.getElementById("catID").value;
                            
    this.prefs.setCharPref("extensions.deliciousblogrescue.delAcc", delAcc);                        
    this.prefs.setIntPref("extensions.deliciousblogrescue.runTimeIndex", runTimeIndex);                 
    this.prefs.setCharPref("extensions.deliciousblogrescue.blogAcc", blogAcc);                        
    this.prefs.setCharPref("extensions.deliciousblogrescue.destURL", destURL);                       
    this.prefs.setCharPref("extensions.deliciousblogrescue.blogID", blogID);                    
    this.prefs.setCharPref("extensions.deliciousblogrescue.catID", catID);
  },
  
  openDialogue: function() {
    // Only open the dialogue if it's not already open -- otherwise just focus it              
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                         .getService(Components.interfaces.nsIWindowMediator);
    var dbrDialog = wm.getMostRecentWindow("mozilla:deliciousblogrescue-dialog");
    if (dbrDialog) {
      dbrDialog.focus();
    }
    else {
      var features = "chrome,resizable,dialog=no";
      dbrDialog = window.openDialog("chrome://deliciousblogrescue/content/dialogue.xul", "deliciousblogrescue-dialogue", features);
    }
  },

  // Executed when user confirms the dialog box.
  accept: function() {	
  	var delAccElmt = document.getElementById("delAcc");
  	var delPassElmt = document.getElementById("delPass");
  	var blogAccElmt = document.getElementById("blogAcc");
  	var blogPassElmt = document.getElementById("blogPass");
  	var runDateElmt = document.getElementById("runDate");
  	var runTimeElmt = document.getElementById("runTime");
  	var destURLElmt = document.getElementById("destURL");
  	
  	if ((delAccElmt.value == "") || (delPassElmt.value == "") || (blogAccElmt.value == "") || (blogPassElmt.value == "") || (destURLElmt.value == "")) {
  		this.reportResults("requiredFieldError");
  		return false;
  	}
  	
    var runTime = runTimeElmt.selectedItem.label;
    var delAcc = delAccElmt.value;
    var delPass = delPassElmt.value;  
  
    // Sub one day off the date, since the API uses the 24 hour period starting from the time you pass it
    var inDate = runDateElmt.dateValue;
    var runDate = new Date(inDate.getFullYear(), inDate.getMonth(), inDate.getDate() - 1);
    var padMonth = (runDate.getMonth() + 1) < 10 ? "0" + (runDate.getMonth() + 1) : runDate.getMonth() + 1
    var padDate = runDate.getDate() < 10 ? "0" + runDate.getDate() : runDate.getDate();
    var startDate = runDate.getFullYear() + "-" + padMonth + "-" + padDate;
    
    var startDateTime = startDate + "T" + runTime + ":00:00Z";
    
    // SJW:20080804
    // Need to calculate both start and end date since get API is currently broken.
    // The all API uses start and end datetimes correctly.
    var endTime = (runTime == 00) ? 23 : parseInt(runTime, 10) - 1;
    endTime = (endTime < 10) ? "0" + endTime : endTime;
    var endDate = (runTime == 00) ? startDate : runDateElmt.value;
    var endDateTime = endDate + "T" + endTime + ":59:59Z";
    
    // SJW:20080804
    // Switch to all API.
    //var url = this.urlDeliciousAPI + this.urlGet + "dt=" + startDateTime;
    var url = this.urlDeliciousAPI + this.urlGet + "fromdt=" + startDateTime + "&todt=" + endDateTime;
    
    // disable all the input fields so data can't be changed as the async calls are made
    document.documentElement.getButton("accept").disabled = true;
    delAccElmt.disabled = true;
    delPassElmt.disabled = true;
    runDateElmt.disabled = true;
    runTimeElmt.disabled = true;
    blogAccElmt.disabled = true;
    blogPassElmt.disabled = true;
    destURLElmt.disabled = true;
    document.getElementById("blogID").disabled = true;
    document.getElementById("catID").disabled = true;
    
    // the last attempt may have displayed the seeError text; hide it again.
    document.getElementById("status-error").hidden = true;
    
    this.setStatus("gettingLinksMessage");
    doHTTPRequest("GET", url, delAcc, delPass, null, this, "delAuthFailure", "delFailure", "delSuccess"); 
    return false;
  },
  
  delSuccess: function(resp) {
    // Executed when the del.icio.us xml data has been returned
    if (resp != null) {
      this.forwardToDest(resp);
    }
    else {
      this.delFailure();
    }
  },
    
  delAuthFailure: function() {
    this.reportResults("delAuthError");
  },
    
  delFailure: function() {
    this.reportResults("delGeneralError");
  },
  
  forwardToDest: function(deliciousXML) {
    
    var req = new XMLHttpRequest();
  	var delAccURL = this.urlDel + document.getElementById("delAcc").value + "/";

    // Get the xslt that maps from XML to HTML 
    req.open("GET", "chrome://deliciousblogrescue/content/transform.xsl", false); 
    req.send(null);
    var transform = req.responseXML;
    var outputXML;
    var myXslProc;
    myXslProc = new XSLTProcessor();
    myXslProc.importStylesheet(transform);
    myXslProc.setParameter(null, "delurl", delAccURL);
    try {    
      outputXML = myXslProc.transformToDocument(deliciousXML);    
    }
    catch(err) {
      this.reportResults("delXSLError");
      return;
    }
    
    var myXMLSerial = new XMLSerializer();
    var outputStr = myXMLSerial.serializeToString(outputXML.documentElement);
    
    // stop if there were no links posted to delicious during the given time period  
    var delLinks  = new XML(outputStr);
    if (delLinks.children()[0].name() != "li") {
      this.reportResults("delNoLinks");
      return;
    }
      
    // Create the content of the MetaWeblog API
    var methodCall = this.constructMetaWeblogCall(outputStr);
  
    // Send that data to the destURL via MetaWeblog API XML-RPC call
    this.setStatus("sendingPostToBlogMessage");
    var destURL = document.getElementById("destURL").value; 
    doHTTPRequest("POST", destURL, "", "", methodCall, this, "metaWeblogFailure", "metaWeblogFailure", "metaWeblogSuccess");   
  },
  
  constructMetaWeblogCall: function(postContent) {    
    var blogAcc = document.getElementById("blogAcc").value;
    var blogPass = document.getElementById("blogPass").value;
    var blogID = document.getElementById("blogID").value;
    var catID = document.getElementById("catID").value;
    var runDate = document.getElementById("runDate").dateValue;
    var dateStr = runDate.getFullYear() + "-" + (runDate.getMonth() + 1) + "-" + runDate.getDate();
    
    // Need to encode the post content as UTF-8, not Unicode (else btoa chokes)
    postContent = unescape(encodeURIComponent(postContent));
      
    // metaWeblog.newPost (blogid, username, password, struct, publish)
    // Right now we're just pushing the description -- later should find out if del.icio.us 
    // also pushes date and categories.    
    var apimethod = "<methodName>metaWeblog.newPost</methodName>";
    var blogid = "<param><value><string>" + blogID + "</string></value></param>";
    var user = "<param><value><base64>" + window.btoa(blogAcc) + "</base64></value></param>";
    var pass = "<param><value><base64>" + window.btoa(blogPass) + "</base64></value></param>";
    var content = "<param><value><struct>";
    content = content + "<member><name>title</name><value><string>links for " + dateStr + "</string></value></member>"
    content = content + "<member><name>description</name><value><base64>" + window.btoa(postContent) + "</base64></value></member>";
    content = content + "<member><name>categories</name><value><array><data><value><string>" + catID + "</string></value></data></array></value></member>";
    content = content + "</struct></value></param>";
    var publish = "<param><value><boolean>" + "true" +  "</boolean></value></param>";
    var params = "<params>" + blogid + user + pass + content + publish + "</params>";
    var methodCall = '<?xml version="1.0"?>' + "<methodCall>" + apimethod + params + "</methodCall>";
    return methodCall;
  },
  
  metaWeblogSuccess: function(resp) {
    // Executed when the MetaWeblog XML-RPC call has been returned
    if (resp != null) {
      // parse the response XML -- a fault code may have been returned.
      var response = new XML (Components.classes['@mozilla.org/xmlextras/xmlserializer;1'].createInstance (Components.interfaces.nsIDOMSerializer).serializeToString(resp.documentElement));
      if (response.name() != 'methodResponse' || !(response.children()[0].name() == "params" || response.children()[0].name() == "fault")) {
        this.reportResults("blogXMLError");
        return;
      }
      if (response.children()[0].name() == "fault") {
          // the call returned a fault string that we need to display
          this.blogFaultStr = response.fault.value.struct.children()[1].value.string;
          this.reportResults("blogFault");
          document.getElementById("status-error").hidden = false;
          return;
      }
      // if we got this far, the post was made successfully!
      var catID = document.getElementById("catID").value;
      if (catID != "") {
        // if a category was specified, we now need to try to add it to the post
        if (response.params.param.value.children()[0].name() != "string") {
      		// couldn't pull the post id from the response
      		this.reportResults("blogSuccessWithCatErr");
      		return;
      	}
      	// Do the mt.setPostCatergories call
      	var postID = response.params.param.value.string;
        var methodCall = this.constructMTCategoryCall(postID); 
        var destURL = document.getElementById("destURL").value;       
        this.setStatus("sendingCatToBlogMessage"); 
        doHTTPRequest("POST", destURL, "", "", methodCall, this, "mtSetCatFailure", "mtSetCatFailure", "mtSetCatSuccess");
        return;
      }
      else { 
      	  // no category specified, so we're done!
          this.reportResults("blogSuccess");
          return;
      }
    }
    else {
      this.reportResults("blogXMLError");
      return;
    }
  },

  metaWeblogFailure: function() {
    this.reportResults("blogHTTPError");
  },
  
  constructMTCategoryCall: function(postID) {    
    var blogAcc = document.getElementById("blogAcc").value;
    var blogPass = document.getElementById("blogPass").value;
    var catID = document.getElementById("catID").value;
      
    // mt.setPostCategories (postid, username, password, categories array)  
    var apimethod = "<methodName>mt.setPostCategories</methodName>";
    var postIDParam = "<param><value><int>" + postID + "</int></value></param>";
    var user = "<param><value><base64>" + window.btoa(blogAcc) + "</base64></value></param>";
    var pass = "<param><value><base64>" + window.btoa(blogPass) + "</base64></value></param>";
    var categories = "<param><value><array><data><value><struct>";
    categories = categories + "<member><name>categoryId</name><value><int>" + catID + "</int></value></member>"
    categories = categories + "<member><name>isPrimary</name><value><int>1</int></value></member>";
    categories = categories + "</struct></value></data></array></value></param>";
    var params = "<params>" + postIDParam + user + pass + categories + "</params>";
    var methodCall = '<?xml version="1.0"?>' + "<methodCall>" + apimethod + params + "</methodCall>";
    return methodCall;
  },
  
  mtSetCatSuccess: function(resp) {
  	if (resp != null) {
  		var response = new XML (Components.classes['@mozilla.org/xmlextras/xmlserializer;1'].createInstance (Components.interfaces.nsIDOMSerializer).serializeToString(resp.documentElement));
  		if (response.name() == 'methodResponse' && response.children()[0].name() == "params") {
      	this.reportResults("blogSuccess");
      	return;
      }
  	}
    this.reportResults("blogSuccessWithCatErr");
  },
  
  mtSetCatFailure: function() {
    this.reportResults("blogSuccessWithCatErr");
  },
    
  showErr: function() {
    if (this.blogFaultStr != "") {
      alert(this.blogFaultStr);
    }
  },
    
  reportResults: function(statusPropName) {
    // re-enable all the controls
    document.documentElement.getButton("accept").disabled = false;
    document.getElementById("delAcc").disabled = false;
    document.getElementById("delPass").disabled = false;
    document.getElementById("runDate").disabled = false;
    document.getElementById("runTime").disabled = false;
    document.getElementById("blogAcc").disabled = false;
    document.getElementById("blogPass").disabled = false;
    document.getElementById("destURL").disabled = false;
    document.getElementById("blogID").disabled = false;
    document.getElementById("catID").disabled = false;
    this.setStatus(statusPropName);
  },
    
  setStatus: function(statusPropName) {
    var msg = document.getElementById("deliciousblogrescue-strings").getString(statusPropName);
    document.getElementById("status-text").value = msg;
    window.sizeToContent();
  }
}

function doHTTPRequest(type, url, username, password, data, aListener, methodAuthErr, methodErr, methodSuccess) {
  var request = new XMLHttpRequest();
  // Open an asynchronous request
  request.open(type, url, true, username, password);
  request.overrideMimeType('text/xml');
  request.setRequestHeader("User-Agent", navigator.userAgent + " deliciousblogrescue.mozdev.org");
                  
  // Basic authentication should be used
  if (username.length > 0) {
    var text = username + ":" + password;
    text = window.btoa(text);
    request.setRequestHeader("Authorization", "Basic " + text);
  }
  request.onreadystatechange = function() {
    // 4 is the "completed" state
    if (request.readyState == 4) {
      switch(request.status) {
        case 200:
          // HTTP "OK". Successfully posted.
          aListener[methodSuccess](request.responseXML); 
          break;
        case 401:
          aListener[methodAuthErr]();
          break;
        default:
          aListener[methodErr]();
          break;
      }
    } 
    return;
  };
  request.send(data);
}